%if 0%{?rhel}
%global with_enca 0
%global with_libcue 0
%global with_rss 0
%else
%global with_enca 1
%global with_libcue 1
%global with_rss 1
%endif

%global tracker_version 3.1.0

%if 0%{?with_rss}
%global systemd_units tracker-extract-3.service tracker-miner-fs-3.service tracker-miner-fs-control-3.service tracker-miner-rss-3.service tracker-writeback-3.service
%else
%global systemd_units tracker-extract-3.service tracker-miner-fs-3.service tracker-miner-fs-control-3.service tracker-writeback-3.service
%endif

# Exclude private libraries from autogenerated provides and requires
%global __provides_exclude_from ^%{_libdir}/tracker-miners-3.0/
%global __requires_exclude ^(libtracker-extract\.so|libtracker-miner-3\.0\.so|libextract-.*\.so|libwriteback-.*\.so)

%global tarball_version %%(echo %{version} | tr '~' '.')

Name:           tracker-miners
Version:        3.1.2
Release:        4%{?dist}
Summary:        Tracker miners and metadata extractors

# libtracker-extract and libtracker-miner libraries are LGPLv2+; the miners are a mix of GPLv2+ and LGPLv2+ code
License:        GPLv2+ and LGPLv2+
URL:            https://gnome.pages.gitlab.gnome.org/tracker/
Source0:        https://download.gnome.org/sources/tracker-miners/3.1/tracker-miners-%{tarball_version}.tar.xz

Patch1: 0001-libtracker-common-Backport-seccomp-additions-from-3..patch
Patch2: stricter-seccomp.diff

BuildRequires:  asciidoc
BuildRequires:  gcc
BuildRequires:  giflib-devel
BuildRequires:  meson
BuildRequires:  systemd
BuildRequires:  pkgconfig(dbus-1)
%if 0%{?with_enca}
BuildRequires:  pkgconfig(enca)
%endif
BuildRequires:  pkgconfig(exempi-2.0)
BuildRequires:  pkgconfig(flac)
BuildRequires:  pkgconfig(gexiv2)
BuildRequires:  pkgconfig(gstreamer-1.0)
BuildRequires:  pkgconfig(gstreamer-pbutils-1.0)
BuildRequires:  pkgconfig(gstreamer-tag-1.0)
BuildRequires:  pkgconfig(icu-i18n)
BuildRequires:  pkgconfig(icu-uc)
%if 0%{?with_libcue}
BuildRequires:  pkgconfig(libcue)
%endif
BuildRequires:  pkgconfig(libexif)
%if 0%{?with_rss}
BuildRequires:  pkgconfig(libgrss)
%endif
BuildRequires:  pkgconfig(libgsf-1)
BuildRequires:  pkgconfig(libgxps)
BuildRequires:  pkgconfig(libiptcdata)
BuildRequires:  pkgconfig(libjpeg)
BuildRequires:  pkgconfig(libnm)
BuildRequires:  pkgconfig(libosinfo-1.0)
BuildRequires:  pkgconfig(libpng)
BuildRequires:  pkgconfig(libseccomp)
BuildRequires:  pkgconfig(libtiff-4)
BuildRequires:  pkgconfig(libxml-2.0)
BuildRequires:  pkgconfig(poppler-glib)
BuildRequires:  pkgconfig(totem-plparser)
BuildRequires:  pkgconfig(tracker-sparql-3.0) >= %{tracker_version}
BuildRequires:  pkgconfig(upower-glib)
BuildRequires:  pkgconfig(vorbisfile)

# renamed in F34
Obsoletes:      tracker3-miners < 3.1.0~rc-2
Conflicts:      tracker3-miners < 3.1.0~rc-2
Provides:       tracker3-miners = %{version}-%{release}
Provides:       tracker3-miners%{?_isa} = %{version}-%{release}

%{?systemd_requires}
Requires:       tracker%{?_isa} >= %{tracker_version}

%description
Tracker is a powerful desktop-neutral first class object database,
tag/metadata database and search tool.

This package contains various miners and metadata extractors for tracker.


%prep
%autosetup -p1 -n tracker-miners-%{tarball_version}


%build
%meson \
  -Dtracker_core=system \
%if ! 0%{?with_libcue}
  -Dcue=disabled \
%endif
%if ! 0%{?with_rss}
  -Dminer_rss=false \
%endif
  -Dsystemd_user_services_dir=%{_userunitdir} \
  %{nil}

%meson_build


%install
%meson_install

%find_lang tracker3-miners


%post
%systemd_user_post %{systemd_units}

%preun
%systemd_user_preun %{systemd_units}

%postun
%systemd_user_postun_with_restart %{systemd_units}


%files -f tracker3-miners.lang
%license COPYING*
%doc AUTHORS NEWS README.md
%config(noreplace) %{_sysconfdir}/xdg/autostart/tracker-miner-fs-3.desktop
%if 0%{?with_rss}
%config(noreplace) %{_sysconfdir}/xdg/autostart/tracker-miner-rss-3.desktop
%endif
%{_libdir}/tracker-miners-3.0/
%{_libexecdir}/tracker*
%{_datadir}/dbus-1/interfaces/org.freedesktop.Tracker3.Miner.Files.Index.xml
%{_datadir}/dbus-1/interfaces/org.freedesktop.Tracker3.Miner.xml
%{_datadir}/dbus-1/services/org.freedesktop.Tracker*
%{_datadir}/glib-2.0/schemas/*
%{_datadir}/tracker3-miners/
%{_mandir}/man1/tracker*.1*
%{_userunitdir}/tracker*.service


%changelog
* Thu Nov 30 2023 Carlos Garnacho <cgarnach@redhat.com> - 3.1.2-4
- Backport stricter seccomp jail
  Resolves: RHEL-12469

* Wed Mar 15 2023 MSVSphere Packaging Team <packager@msvsphere.ru> - 3.1.2-3
- Rebuilt for MSVSphere 9.1.

* Tue Nov 22 2022 Carlos Garnacho <cgarnach@redhat.com> - 3.1.2-3
- Do not include RSS miner service on RHEL
  Resolves: rhbz#2041633

* Tue Nov 01 2022 Carlos Garnacho <cgarnach@redhat.com> - 3.1.2-2
- Backport seccomp rules from recent releases
  Resolves: rhbz#2130143

* Wed Aug 25 2021 Kalev Lember <klember@redhat.com> - 3.1.2-1
- Update to 3.1.2

* Tue Aug 10 2021 Mohan Boddu <mboddu@redhat.com> - 3.1.1-3
- Rebuilt for IMA sigs, glibc 2.34, aarch64 flags
  Related: rhbz#1991688

* Fri Apr 16 2021 Mohan Boddu <mboddu@redhat.com> - 3.1.1-2
- Rebuilt for RHEL 9 BETA on Apr 15th 2021. Related: rhbz#1947937

* Sat Apr 03 2021 Kalev Lember <klember@redhat.com> - 3.1.1-1
- Update to 3.1.1

* Mon Mar 22 2021 Kalev Lember <klember@redhat.com> - 3.1.0-1
- Update to 3.1.0

* Fri Mar 19 2021 Kalev Lember <klember@redhat.com> - 3.1.0~rc-3
- Add conflicts with tracker3-miners to help with the upgrade path

* Fri Mar 19 2021 Kalev Lember <klember@redhat.com> - 3.1.0~rc-2
- Update to 3.1.0.rc, based on earlier tracker3-miners packaging
- Obsolete separate tracker3-miners package

* Wed Jan 27 2021 Fedora Release Engineering <releng@fedoraproject.org> - 2.3.5-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Tue Nov 03 2020 Adam Williamson <awilliam@redhat.com> - 2.3.5-2
- Backport patch to allow newfstatat and fstatat64 syscalls (#1892452)

* Mon Sep 07 2020 Kalev Lember <klember@redhat.com> - 2.3.5-1
- Update to 2.3.5

* Mon Sep 07 2020 Kalev Lember <klember@redhat.com> - 2.3.4-2
- Backport an upstream patch to allow statx syscall (#1875398)

* Tue Aug 25 2020 Kalev Lember <klember@redhat.com> - 2.3.4-1
- Update to 2.3.4

* Wed Jul 29 2020 Fedora Release Engineering <releng@fedoraproject.org> - 2.3.3-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Sat May 16 2020 Pete Walter <pwalter@fedoraproject.org> - 2.3.3-2
- Rebuild for ICU 67

* Tue Mar 10 2020 Kalev Lember <klember@redhat.com> - 2.3.3-1
- Update to 2.3.3

* Wed Feb 19 2020 Kalev Lember <klember@redhat.com> - 2.3.2-2
- Backport a fix for tracker erroring out with "Failed to set scheduler settings"

* Wed Feb 19 2020 Kalev Lember <klember@redhat.com> - 2.3.2-1
- Update to 2.3.2

* Fri Jan 31 2020 Fedora Release Engineering <releng@fedoraproject.org> - 2.3.1-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Fri Jan 17 2020 Marek Kasik <mkasik@redhat.com> - 2.3.1-3
- Rebuild for poppler-0.84.0

* Sat Nov 30 2019 Adam Williamson <awilliam@redhat.com> - 2.3.1-2
- Rebuild with libosinfo 1.7.0

* Fri Nov 29 2019 Kalev Lember <klember@redhat.com> - 2.3.1-1
- Update to 2.3.1

* Fri Nov 01 2019 Pete Walter <pwalter@fedoraproject.org> - 2.3.0-2
- Rebuild for ICU 65

* Mon Sep 09 2019 Kalev Lember <klember@redhat.com> - 2.3.0-1
- Update to 2.3.0

* Fri Sep 06 2019 Nikola Forró <nforro@redhat.com> - 2.2.99.1-2
- Rebuilt for exempi 2.5.1

* Fri Sep 06 2019 Kalev Lember <klember@redhat.com> - 2.2.99.1-1
- Update to 2.2.99.1

* Mon Aug 12 2019 Kalev Lember <klember@redhat.com> - 2.2.99.0-1
- Update to 2.2.99.0

* Sat Jul 27 2019 Fedora Release Engineering <releng@fedoraproject.org> - 2.2.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Fri May 03 2019 David King <amigadave@amigadave.com> - 2.2.2-1
- Update to 2.2.2

* Fri Mar 08 2019 Kalev Lember <klember@redhat.com> - 2.2.1-1
- Update to 2.2.1

* Thu Feb 21 2019 Kalev Lember <klember@redhat.com> - 2.2.0-3
- Exclude private libraries from autogenerated provides and requires

* Thu Feb 21 2019 Kalev Lember <klember@redhat.com> - 2.2.0-2
- Fix the package to be installable again

* Wed Feb 20 2019 Kalev Lember <klember@redhat.com> - 2.2.0-1
- Update to 2.2.0
- Switch to the meson build system

* Sun Feb 03 2019 Fedora Release Engineering <releng@fedoraproject.org> - 2.1.5-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Wed Jan 23 2019 Pete Walter <pwalter@fedoraproject.org> - 2.1.5-3
- Rebuild for ICU 63

* Mon Jan 21 2019 Kevin Fenzi <kevin@scrye.com> - 2.1.5-2
- Rebuild to drop libiptcdata deps

* Fri Sep 28 2018 Kalev Lember <klember@redhat.com> - 2.1.5-1
- Update to 2.1.5

* Wed Sep 05 2018 Kalev Lember <klember@redhat.com> - 2.1.4-2
- Rebuilt with fixed vala

* Tue Sep 04 2018 Kalev Lember <klember@redhat.com> - 2.1.4-1
- Update to 2.1.4

* Mon Sep 03 2018 Kalev Lember <klember@redhat.com> - 2.1.3-1
- Update to 2.1.3

* Sun Aug 19 2018 Kalev Lember <klember@redhat.com> - 2.1.1-1
- Update to 2.1.1

* Wed Jul 25 2018 Kalev Lember <klember@redhat.com> - 2.1.0-1
- Update to 2.1.0

* Sat Jul 14 2018 Fedora Release Engineering <releng@fedoraproject.org> - 2.0.5-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Tue Jul 10 2018 Pete Walter <pwalter@fedoraproject.org> - 2.0.5-2
- Rebuild for ICU 62

* Tue Jun 26 2018 Kalev Lember <klember@redhat.com> - 2.0.5-1
- Update to 2.0.5

* Mon Apr 30 2018 Pete Walter <pwalter@fedoraproject.org> - 2.0.4-4
- Rebuild for ICU 61.1

* Sun Feb 11 2018 Sandro Mani <manisandro@gmail.com> - 2.0.4-3
- Rebuild (giflib)

* Thu Feb 08 2018 Kalev Lember <klember@redhat.com> - 2.0.4-2
- Rebuild to really enable the RAW extractor

* Wed Feb 07 2018 Kalev Lember <klember@redhat.com> - 2.0.4-1
- Update to 2.0.4
- Enable new gexiv2 based RAW extractor

* Thu Nov 30 2017 Pete Walter <pwalter@fedoraproject.org> - 2.0.3-2
- Rebuild for ICU 60.1

* Tue Nov 21 2017 Kalev Lember <klember@redhat.com> - 2.0.3-1
- Update to 2.0.3

* Fri Oct 06 2017 Kalev Lember <klember@redhat.com> - 2.0.2-1
- Update to 2.0.2

* Tue Sep 19 2017 Kalev Lember <klember@redhat.com> - 2.0.0-3
- Backport a fix for a crash when processing virtual elements (#1488707)

* Fri Sep 15 2017 Kalev Lember <klember@redhat.com> - 2.0.0-2
- Package review fixes (#1491725):
- Pass --disable-mp3 to use the generic gstreamer extractor
- Disable libstemmer support to match the previous behaviour
- Fix removing .so symlinks for private libraries
- Remove ldconfig rpm scripts as we don't install any shared libraries
- Correct license tag and add comment explaining mixed source licensing

* Thu Sep 14 2017 Kalev Lember <klember@redhat.com> - 2.0.0-1
- Initial Fedora packaging
